#pragma pack(1)
#include "header.h"
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>


void init_read(BITFILE *bf)
{
	bf->status=0;
	bf->buffer_index=BUFFERSIZE;
}

void init_write(BITFILE *bf)
{
	bf->status=0;
	bf->buffer_index=0;
	bf->char_index=8;
	bf->buffer[0]=0;
}

__int16 read_bit(BITFILE *bf)
{
 byte ch;
 __int16 value;
 if(bf->handle==-1 || bf->status==1) return -1;
 else if(bf->buffer_index==BUFFERSIZE ||
	(bf->char_index==0 &&bf->buffer_index==bf->bytes_read-1))
  {
  bf->bytes_read=_read(bf->handle,bf->buffer,BUFFERSIZE);
  if(bf->bytes_read==0)
  {
   bf->status=1;
   return -1;
  }
  bf->char_index=8;
  bf->buffer_index=0;
  }

 if(bf->char_index==0)
 {
  bf->buffer_index++;
  bf->char_index=8;
 }
 ch=bf->buffer[bf->buffer_index];
 value=getbit(ch,bf->char_index);
 bf->char_index--;
 return value;
}


__int16 write_bit(BITFILE *bf,__int16 bit_value)
{
 
 if(bf->handle==-1 || bf->status==1) return -1;
 else if( (bf->buffer_index==BUFFERSIZE-1 && bf->char_index==0)
	 ||(bit_value==-1))
   {
   if(!(bf->buffer_index==0 && bf->char_index==8))
   _write(bf->handle,bf->buffer,bf->buffer_index+1);
	     
   if(bit_value==-1)
   {
    bf->status=1;
    return -1;
   }
   bf->char_index=8;
   bf->buffer_index=0;
   bf->buffer[bf->buffer_index]=0;
  }

 if(bf->char_index==0)
 {
  bf->buffer_index++;
  bf->char_index=8;
  bf->buffer[bf->buffer_index]=0;
 }
 if(bit_value==1)
  setbit(&bf->buffer[bf->buffer_index],bf->char_index);
 bf->char_index--;
 return 0;
}

__int16 getbit(byte num,byte pos)
{
  __int16 i=1;
  if (pos!=1) i=(i<<(pos-1));
  if((num&i)==0) return 0;
  else return 1;
}

void setbit(byte *num,byte pos)
{
  __int16 i=1;
  if (pos!=1) i=(i<<(pos-1));
  *num=((*num)|i);
}

__int16 read_bits(BITFILE *bf,dword *num,__int16 bits)
{
	dword i;
	__int16 j,bit;

	if(bits>=0 && bits<=32)
	{
       *num=0;
	   i=1;
	   if(bits!=1)i=i<<(bits-1);
	   j=1;
	   while(j<=bits)
	   {
          bit=read_bit(bf);
		  if(bit==-1) return (j-1);
		  else if(bit==1) *num=((*num)|i);
		  j++;
		  i=i>>1;
	   }

	return (j-1);

	}
	else return -1;
}
	   
__int16 write_bits(BITFILE *bf,dword num,__int16 bits)
{
	dword i;
	__int16 j,bit;

	if(bits>=0 && bits<=32)
	{
       i=1;
	   if(bits!=1)i=i<<(bits-1);
	   j=1;
	   while(j<=bits)
	   {
          if((num&i)==0) bit=0; else bit=1;
		  if(write_bit(bf,bit)==-1) return -1;
		  j++;
		  i=i>>1;
	   }

	return 0;
	}
	return -1;
}
	   
